/* @(#) SupportPacks/ms0c/public/mqsecrtn.h, supportpacks, p000, p000-L000330          1.3  99/05/22 22:34:30 */
#ifndef _MQSECRTN_H
#define _MQSECRTN_H
/*---------------------------------------------------------------
 *  Author(s)     : Benjamin Y. Goldshlager
 *
 *  Description:
 *      This the header file for the MQ Channel Security Exit
 *      GSS-API routines.
 *
 *      This code is base on amqdcexc.c Sample
 *
 *
 *  Notes:
 *
 *  Change Log:
 *    $Log$
 *
 *    Who      Date       Defect   Description
 *    ---      --------   ------   -----------
 *
 *--------------------------------------------------------------*/
#include "mqsecche.h"

char* perrorGSS (PEXITLOCALVARS pExitLocalVars,
	 OM_uint32              uiMajor,
	 OM_uint32              uiMinor);

char *convertGSSNameToString (PEXITLOCALVARS pExitLocalVars,
	        gss_name_t internalGSSName);

BOOL IsStatusOK (PEXITLOCALVARS pExitLocalVars,
	 char                   *pszSource,
	 int                    iLine,
	 OM_uint32              gssMajorStatus,
	 OM_uint32              gssMinorStatus,
	 OM_uint32              gssExpectedMajorStatus,
	 OM_uint32              gssExpectedMinorStatus,
	 char                   *pszMsgPrefix,
	 BOOL                   bWarn);

void displaySecContext (PEXITLOCALVARS pExitLocalVars,
	    char *pre_s,
	    gss_ctx_id_t ctxt,
	    int display_peer_certs);

MQLONG initEntrustEnv (PEXITLOCALVARS   pExitLocalVars);

MQLONG compareMQNames (PEXITLOCALVARS   pExitLocalVars,
	     PMQCHAR                      pTargetName,
	     PMQCHAR                      pPartnerName,
	     MQLONG                       ChannelType,
	     PMQCHAR                      pChannelName,
	     PMQCHAR                      pThisQMgrName);

MQLONG  compareDNNames (PEXITLOCALVARS  pExitLocalVars,
	    char*                   pszTargetNameDN,
	    gss_name_t              PartnerGSSName,
	    PMQCHAR                 pChannelName);

MQLONG initSecurityExit (PMQCHAR32              pExitData,
	     char*                  szChannelName,
	     PEXITUSERAREA  pUserExitArea,
	     PCONTEXTDATA   pContext);

MQLONG initMessageExit (PMQCHAR32               pExitData,
	    char*                   szChannelName,
	    PEXITUSERAREA   pUserExitArea);

MQLONG savePartnerName (PEXITUSERAREA   pExitUserArea,
	    gss_name_t              *pPartnerGSSName,
	    PMQCHAR48               pPartnerName,
	    PMQBYTE                 pChannelName);

MQLONG acquireCred (PMQCXP                pParm,
	  PMQCD         pChDef,
	  gss_cred_id_t *pCredHandle,
	  gss_ctx_id_t  *pContextHandle,
	  PMQBYTE       pName);

MQLONG createCreds (PMQCXP                      pParms,
	  PMQCD                   pChDef,
	  gss_cred_id_t   *pCredHandle,
	  gss_ctx_id_t    *pContextHandle);

MQLONG setKeyEstblishmentProtocol (PEXITLOCALVARS pExitLocalVars,
	           gss_cred_id_t  credentialHandle);

void composeSecMsg (PMQCXP   pParms,
	  PMQBYTE  *pExitBufAddr,
	  PMQLONG  pExitBufLen,
	  PMQBYTE  pHeader,
	  MQLONG   headerLength,
	  MQBYTE   msgType,
	  PMQBYTE  msg,
	  MQLONG   msgLength,
	  MQLONG   exitReturnCode,
	  PMQCHAR  pChannelName);

void composeSecTokenMsg (PMQCXP          pParms,
	     OM_uint32       major_status,
	     OM_uint32       minor_status,
	     MQBYTE          msgType,
	     gss_buffer_desc *pOutputToken,
	     PMQBYTE         *pOutputMsgAddr,
	     PMQLONG         pOutputMsgLength,
	     PMQCHAR         pChannelName);

void initSecContext (PMQCXP       pParms,
	   PSECEXITDATA pSecData,
	   PCONTEXTDATA pContextData,
	   PMQBYTE      pInputMsgAddr,
	   MQLONG       inputMsgLength,
	   PMQBYTE      *pOutputMsgAddr,
	   PMQLONG      pOutputMsgLength,
	   PMQCHAR      pChannelName);

void acceptSecContext (PMQCXP       pParms,
	   PSECEXITDATA pSecData,
	   PCONTEXTDATA pContextData,
	   PMQBYTE      pInputMsgAddr,
	   MQLONG       inputMsgLength,
	   PMQBYTE      *pOutputMsgAddr,
	   PMQLONG      pOutputMsgLength,
	   PMQCHAR      pChannelName);

void terminateSecurityExit (PMQCXP               pParms,
	      PSECEXITDATA pSecData,
	      PCONTEXTDATA pContext);

MQLONG compareNames (PEXITLOCALVARS pExitLocalVars,
	   PMQCHAR                pTargetName,
	 PMQCHAR            pPartnerName);

MQLONG verifyTargetName (PMQCXP pParms, PMQCD pChDef);

void processSecurityMessage (PMQCXP     pParms,
	       PMQCD      pChDef,
	       PGSSSECMSG pInMsgAddr,
	       MQLONG     inMsgLength,
	       PMQPTR     pOutMsgAddr,
	       PMQLONG    pOutMsgLength);

MQLONG sealData (PEXITLOCALVARS         pExitLocalVars,
	 PMQCXP                         pParms,
	 gss_ctx_id_t           hContext,
	 gss_buffer_desc*       pInBuffer,
	 gss_buffer_desc*       pOutBuffer);

MQLONG unSealData (PEXITLOCALVARS       pExitLocalVars,
	   PMQCXP                       pParms,
	   gss_ctx_id_t         hContext,
	   gss_buffer_desc*     pInBuffer,
	   gss_buffer_desc*     pOutBuffer);

#endif          // _MQSECRTN_H
