/* @(#) SupportPacks/ms0c/public/mqsecutl.h, supportpacks, p000, p000-L000330          1.3  99/05/22 22:34:34 */
#ifndef _MQSECUTL_H
#define _MQSECUTL_H
/*---------------------------------------------------------------
 *  Author(s)     : Benjamin Y. Goldshlager
 *
 *  Description:
 *      This the header file for the MQ Channel Security Exit
 *      utility routines.
 *
 *      This code is base on amqdcexc.c Sample
 *
 *
 *  Notes:
 *
 *  Change Log:
 *    $Log$
 *
 *    Who      Date       Defect   Description
 *    ---      --------   ------   -----------
 *
 *--------------------------------------------------------------*/
#include "mqsecche.h"

#define ENTRUST_PW_LEN   256
#define MAX_LINE        2048
#define SYSLOG_BUFF_LEN 2048

char* baseName (char* pszFileName);

void freeExitUserArea (PMQCXP pParms);

char* stripLeadingAndTrailingBlanks (char* szToken);

BOOL isStringNumeric (char* pszNumber);

int readINIFile (char* pszINIFile,
	 PEXITLOCALVARS *pExitLocalVars);

void convertMQCHARToString (char* szString,
	      PMQCHAR mqIn,
	      int iLen);

BOOL setINIDefaults (PEXITLOCALVARS pVars);

void dumpINIFields (PEXITLOCALVARS pExitLocalVars,
	  char* pszINIFile);

int pUserExitArea (char* pLine,
	   char** pszParm,
	   char** pszValue);

int getPassword (PEXITLOCALVARS pExitLocalVars,
	 char* pszKeyTab,
	 char* pszLocalQMgrName,
	 char* pszPW,
	 int   iPwLen);

const char* getExitReasonStr (MQLONG lCode);

const char* getExitIdStr (MQLONG lCode);

const char* getExitResponseStr (MQLONG lCode);

char* prefixMsg (char*            pszOutMsg,
	 const  int       iOutMsgLen,
	 const  char* pszInMsg,
	 const  char* pszMsgPrefix);

void dtkDisplay (const PEXITLOCALVARS pLocalVars,
	 char *fmt, ...);

void dtkWarning (const PEXITLOCALVARS pLocalVars,
	 char *fmt, ...);

void dtkError (const PEXITLOCALVARS pLocalVars,
	 char *fmt, ...);

void dtkDebug (const PEXITLOCALVARS pLocalVars,
	 char *fmt, ...);

void dtkDebug2 (const PEXITLOCALVARS pLocalVars,
	 char *fmt, ...);

void dtkWriteSysLogEvent (
#if MQAT_DEFAULT==MQAT_WINDOWS_NT
	      WORD wEventType,
	      DWORD dwEventID,
#elif MQAT_DEFAULT==MQAT_UNIX
	      int iEventType,
#else
#error Unsupported platform
#endif
	      char *pszMsg);

char* getTimeStamp (char* pszTimeStamp);

#endif          // _MQSECUTL_H
